<!doctype html>
<html lang="en">
   <head>
      <!-- Required meta tags -->
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

      <!-- Bootstrap CSS -->
      <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

      <title>Simple Upload Form</title>
   </head>
   <body>
      <div class="row  justify-content-center">
         <div class="card">
            <div class="card-header">
               <h5 class="card-body"> Simple Upload Form </h5>
            </div>
            <div class="card-body">
               <form class="was-validated" enctype="multipart/form-data" method="POST" action="/api/form-create-vc">
                  <div class="mb-3">
                     <label for="participant">Participant Name</label>
                     <input type="text" class="form-control" name="participant" id="participant" placeholder="dufourstorage" required>
                     <div class="invalid-feedback">Please enter a name</div>
                  </div>

                  <div class="mb-3">
                     <label for="certificationType">Certification Type</label>
                     <select class="custom-select" name="certificationType" id="certificationType" required>
                        <option value="">Certification Type</option>
                        <option value='ISO 27001'>ISO 27001</option>
                        <option value='SecNumCloud'>SecNumCloud</option>
                        <option value='C5 type I'>C5 type I</option>
                        <option value='C5 type II'>C5 type II</option>
                        <option value='CISPE Data Protection CoC'>CISPE Data Protection CoC</option>
                        <option value='CNDCP'>CNDCP</option>
                        <option value='CSA STAR Level 2'>CSA STAR Level 2</option>
                        <option value='CSA STAR type I'>CSA STAR type I</option>
                        <option value='CSA STAR type II'>CSA STAR type II</option>
                        <option value='Cyber Essentials Plus Certification'>Cyber Essentials Plus Certification</option>
                        <option value='ENS'>ENS</option>
                        <option value='ENS  Espana (Royal Decree 3/2010)'>ENS  Espana (Royal Decree 3/2010)</option>
                        <option value='Fair Software Licensing'>Fair Software Licensing</option>
                        <option value='GSMA'>GSMA</option>
                        <option value='HDS-FR'>HDS-FR</option>
                        <option value='ISO 14001'>ISO 14001</option>
                        <option value='ISO 20000'>ISO 20000</option>
                        <option value='ISO 27017'>ISO 27017</option>
                        <option value='ISO 27018'>ISO 27018</option>
                        <option value='ISO 27701'>ISO 27701</option>
                        <option value='ISO 45001'>ISO 45001</option>
                        <option value='ISO 50001'>ISO 50001</option>
                        <option value='ISO 9001'>ISO 9001</option>
                        <option value='NEN 7510'>NEN 7510</option>
                        <option value='PCI-DSS'>PCI-DSS</option>
                        <option value='PCI_DSS_Level1'>PCI_DSS_Level1</option>
                        <option value='PiTuKri ISAE 3000 Type II'>PiTuKri ISAE 3000 Type II</option>
                        <option value='SAP : cloud and infrastructure'>SAP : cloud and infrastructure</option>
                        <option value='SOC type I'>SOC type I</option>
                        <option value='SOC type II'>SOC type II</option>
                        <option value='SWIPO IaaS CoC'>SWIPO IaaS CoC</option>
                        <option value='TISAX'>TISAX</option>
                     </select>
                     <div class="invalid-feedback">Invalid certification type</div>
                  </div>

                  <div class="mb-3">
                     <label for="file"> PDF Document </label>
                     <input type="file" class="form-control" name="file" id="file" required/>
                     <div class="invalid-feedback">Invalid file</div>
                  </div>

                  <div class="mb-3">
                     <label for="serviceOffering"> ServiceOffering Json Object </label>
                     <textarea class="form-control" name="serviceOffering" id="serviceOffering" rows="65"></textarea>
                     <div class="invalid-feedback">Invalid Json</div>
                  </div>

                  <div class="mb-3">
                     <!--<button type="submit" class="btn btn-primary">Form Submit</button>-->
                     <button type="button" id="sendButton" class="btn btn-primary">API Submit</button>
                  </div>

                  <div class="mb-3">
                     <pre id="success" style="background-color:green;"></pre>
                     <pre id="error" style="background-color:red;"></pre>
                     <p id="b64file" hidden></p>
                  </div>
               </form>
            </div>
         </div>
      </div>
   
      <!-- jQuery first, then Popper.js, then Bootstrap JS -->
      <script src="https://code.jquery.com/jquery-3.5.1.min.js" integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0=" crossorigin="anonymous"></script>
      <script src="https://cdn.jsdelivr.net/npm/popper.js@1.14.7/dist/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
      <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
      <script>
         const characters ='abcdef0123456789';
         function generateString(length) {
            let result = '';
            const charactersLength = characters.length;
            for ( let i = 0; i < length; i++ ) {
               result += characters.charAt(Math.floor(Math.random() * charactersLength));
            }

            return result;
         }
         var did = "did:web:dufourstorage.provider.gaia-x.community:participant:1225ed1cc7755bc5867413f1ca1cf99eb66d4f7a148e10e346390c4bb302f649/service-offering/"+generateString(64)+"/data.json"
         var serviceOfferingJson = {
            "@context": {
               "dct": "http://purl.org/dc/terms/",
               "dcat": "http://www.w3.org/ns/dcat#",
               "xsd": "http://www.w3.org/2001/XMLSchema#",
               "gax-compliance": "https://schemas.abc-federation.gaia-x.community/wip/vocab/compliance#",
               "gax-participant": "https://schemas.abc-federation.gaia-x.community/wip/vocab/participant#",
               "gax-service": "https://schemas.abc-federation.gaia-x.community/wip/vocab/service#"
            },
            "@id": did,
            "@type": "gax-service:ServiceOffering",
            "gax-service:providedBy": {
               "@id": "did:web:dufourstorage.provider.gaia-x.community:participant:1225ed1cc7755bc5867413f1ca1cf99eb66d4f7a148e10e346390c4bb302f649/data.json"
            },
            "gax-service:termsAndConditions": {
               "@type": "gax-core:TermsAndConditions",
               "gax-core:Value": {
                     "@value": "https://www.example.com/",
                     "@type": "xsd:anyURI"
               },
               "gax-core:hash": {
                     "@value": "31296ef8727fc63e89213f3e5ab928bae7699b6dade0af5e443b8ad2623639ee8e6176696a1fa125ccfa7fa55465463b6424d3f54435d6a2beafd79a91425b0a",
                     "@type": "xsd:string"
               }
            },
            "gax-service:serviceTitle": {
               "@value": "Storage Service",
               "@type": "xsd:string"
            },
            "gax-service:serviceType": [
               {
                     "@value": "Storage",
                     "@type": "xsd:string"
               }
            ],
            "gax-service:providerServiceId": {
               "@value": "S-01",
               "@type": "xsd:string"
            },
            "dct:description": "Storage Service is a service offered by DUFOURSTORAGE",
            "dcat:keyword": [
               {
                     "@value": "Storage",
                     "@type": "xsd:string"
               }
            ],
            "gax-service:layer": [
               {
                     "@value": "IAAS",
                     "@type": "xsd:string"
               }
            ],
            "gax-service:isAvailableOn": [
               {
                     "@id": "did:web:dufourstorage.provider.gaia-x.community:participant:1225ed1cc7755bc5867413f1ca1cf99eb66d4f7a148e10e346390c4bb302f649/location/cdaf622d545337367680b2da15f86f58efb3e8cdcae82b23ebcf1dfb20c04bda/data.json"
               }
            ]
         };
         document.getElementById('serviceOffering').innerHTML = JSON.stringify(serviceOfferingJson, undefined, 4);
         document.getElementById('participant').value = 'dufourstorage';
         
         document.getElementById('sendButton').addEventListener("click", function(e) {
            document.getElementById('error').innerText = "";
            document.getElementById('success').innerText = "Waiting for the notarization...";

            e.preventDefault();
            $.ajax({
               type: "POST",
               url: "/api/v2206/create-vc",
               contentType: "application/json; charset=utf-8",
               data: JSON.stringify({ 
                  "participant": document.getElementById('participant').value,
                  "certificationType": document.getElementById('certificationType').value,
                  "b64file": document.getElementById('b64file').innerText,
                  "serviceOffering": JSON.parse(document.getElementById('serviceOffering').value)
               }),
               success: function(result) {
                  console.log(result);
                  var txt = JSON.stringify(result, null, 2);
                  document.getElementById('error').innerText = "";
                  document.getElementById('success').innerText = txt;
                  
               },
               error: function(result) {
                  console.log(result);
                  var txt = result.status + ": " + result.statusText;
                  document.getElementById('success').innerText = "";
                  document.getElementById('error').innerText = txt;
               }
            });
         });
         
         document.getElementById('file').addEventListener("change", async (e) => {
            var b64file = await convertBase64( $('#file')[0].files[0] );
            b64file = b64file.split('base64,')[1];
            document.getElementById('b64file').innerText = b64file;
         });

         const convertBase64 = (file) => {
            return new Promise((resolve, reject) => {
               const fileReader = new FileReader();
               fileReader.readAsDataURL(file);

               fileReader.onload = () => {
                     resolve(fileReader.result);
               };

               fileReader.onerror = (error) => {
                     reject(error);
               };
            });
         };
      </script>
   </body>
</html>